using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Net;
using System.Net.Sockets;

/*
 * TODO CxgĂяoCMobt@(byte[])̂܂ܓn
 *        QƂ݂̂n\(Ƃ؂)̂ŁC
 *         f[^𕡐œn
 *       Mobt@𒼐ڗpStreamBufferNX
 *        Mɂ킹ăf[^Rs[悤ɂȂĂ邪C
 *         ̎𗊂̂͂_
 */

namespace Client.Stream
{
    public class ByteArrayReadEventArgs : EventArgs
    {
        /// <summary>
        /// Mf[^
        /// </summary>
        public byte[] readData;
        /// <summary>
        /// Mf[^
        /// </summary>
        public int readBytes;
    }

    /// <summary>
    /// ΃sA/T[o\PbgD
    /// 񓯊\PbgȒPɈNXD
    /// </summary>
    public class AsyncSocket
    {
        protected const int TimeOutMS = 2000;
        protected ManualResetEvent connectDone = new ManualResetEvent(false);

        protected const int BufferSize = 1024;
        protected byte[] buffer = new byte[BufferSize];
        
        protected Socket mySocket;

        // public delegate void ReadEventHandler(object sender, ReadEventArgs e);
        /// <summary>
        /// f[^MCxgDReadEventArgsIuWFNgɃf[^i[Ă܂D
        /// </summary>
        public event EventHandler<ByteArrayReadEventArgs> Read = delegate(object s, ByteArrayReadEventArgs e) { };
        public event EventHandler Closed = delegate(object s, EventArgs e) { };

        public AsyncSocket()
        {
            mySocket =new Socket(AddressFamily.InterNetwork, 
                              SocketType.Stream, ProtocolType.Tcp );
        }

        // MJn܂D
        private void Start()
        {
            if (null == mySocket)
                return;

            mySocket.BeginReceive(buffer, 0, BufferSize, SocketFlags.None,
                new AsyncCallback(ReadCallback), mySocket);
        }

        /// <summary>
        /// TCPڑs܂D
        /// </summary>
        /// <param name="ipAddress">IPAhX</param>
        /// <param name="port">|[g</param>
        /// <returns>true: , false: s</returns>
        public bool Connect(string ipAddress, int port)
        {
            if (null == mySocket)
                return false;

            connectDone.Reset();
            IAsyncResult ar = mySocket.BeginConnect(ipAddress, port, new AsyncCallback(ConnectCallback), mySocket);

            Trace.Logger.Write("  try " + ipAddress + ":" + port.ToString(), Client.Trace.Logger.LogLevel.L7_DEBUG);

            if (connectDone.WaitOne(TimeOutMS, false))
            {
                // 
                try
                {
                    mySocket.EndConnect(ar);
                    Start();
                    Trace.Logger.Write("  ok.", Client.Trace.Logger.LogLevel.L7_DEBUG);
                    return true;
                }
                catch (Exception e)
                {
                    Close();
                    Trace.Logger.Write("  ng.", Client.Trace.Logger.LogLevel.L7_DEBUG);
                    return false;
                }
            }
            else
            {
                // s
                //   Close=>nullConnectCallback=>falseԂ
                Close();
                try
                {
                    mySocket.EndConnect(ar);
                }
                catch (Exception e)
                {

                }
                Trace.Logger.Write("  ng.", Client.Trace.Logger.LogLevel.L7_DEBUG);
                return false;
            }

        }

        /// <summary>
        /// ڑς݃\PbgQƂ܂D
        /// </summary>
        /// <param name="referenceSocket"></param>
        /// <returns></returns>
        public bool Set(object referenceSocket)
        {
            if (null == mySocket)
                return false;

            if (referenceSocket is Socket)
            {
                mySocket = (Socket)referenceSocket;
                Start();
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// f[^񓯊őM܂D߂ĺCMJnłǂłD
        /// </summary>
        /// <param name="sendData">Mf[^</param>
        /// <param name="sendBytes">f[^</param>
        /// <returns></returns>
        public bool Send(byte[] sendData, int sendBytes)
        {
            try
            {
                mySocket.BeginSend(sendData, 0, sendBytes, SocketFlags.None, new AsyncCallback(SendCallback), mySocket);
                return true;
            }
            catch (Exception es)
            {
                Close();
                Closed(this, EventArgs.Empty);
                return false;
            }
        }


        public IPEndPoint GetRemoteEndPoint()
        {
            try
            {
                return (IPEndPoint)mySocket.RemoteEndPoint;
            }
            catch
            {
                return null;
            }
        }

        /// <summary>
        /// ؒfC\[X܂D̃IuWFNg͍ėpł܂D
        /// </summary>
        public bool Close()
        {
            try
            {
                // FIN(0oCgRead)ɑ΂ClosȅꍇCShutdown͕sv
                mySocket.Shutdown(SocketShutdown.Both);
            }
            catch { }
            try
            {
                mySocket.Close();
            }
            catch { }
            
            mySocket = null;
            return true;
        }

        // ڑR[obN
        private void ConnectCallback(IAsyncResult ar)
        {
            Socket connectSocket = (Socket)ar.AsyncState;

            if (null != connectSocket)
                connectDone.Set();
        }

        // MR[obN
        private void ReadCallback(IAsyncResult ar)
        {
            try
            {
                Socket receiveSocket = (Socket)ar.AsyncState;
                int bytesRead = receiveSocket.EndReceive(ar);

                // MƂ́CCxgĂяođs
                if (bytesRead > 0)
                {
                    ByteArrayReadEventArgs baReadEventArgs = new ByteArrayReadEventArgs();
                    baReadEventArgs.readData = buffer;
                    baReadEventArgs.readBytes = bytesRead;
                    Read(this, baReadEventArgs);
                    mySocket.BeginReceive(buffer, 0, BufferSize, SocketFlags.None,
                        new AsyncCallback(ReadCallback), mySocket);
                }
                // G[Ƃ́C\PbgĐؒfʒm
                else
                {
                    Close();
                    Closed(this, EventArgs.Empty);
                }
            }
            catch { }
        }

        // MR[obN
        private void SendCallback(IAsyncResult ar)
        {
            Socket sendSocket = (Socket)ar.AsyncState;
            try
            {
                int bytesSent = sendSocket.EndReceive(ar);
                if (bytesSent <= 0)
                    throw new ApplicationException("MG[łD");
            }
            catch
            {
                Close();
                Closed(this, EventArgs.Empty);
            }
        }
    }
}
