using System;
using System.Collections.Generic;
using System.Text;

namespace Client.Stream
{
    /// <summary>
    /// Xg[obt@D
    /// oCgzf[^Xg[Ƃĕێ܂D
    /// </summary>
    class StreamBuffer
    {
        List<byte[]> bufferList = new List<byte[]>();
        int bufferReadOffset;

        // obt@ǉ
        private void internalAdd(byte[] addData, int addBytes)
        {
            byte[] addPerfectData = new byte[addBytes];
            Array.Copy(addData, 0, addPerfectData, 0, addBytes);

            lock (bufferList)
            {
                bufferList.Add(addPerfectData);
            }
        }

        // obt@ǂݏo
        private byte[] internalGet()
        {
            byte[] returnData;

            lock (bufferList)
            {
                returnData = new byte[internalGetSize()];
                int offset = 0, size = 0;

                foreach (byte[] buffer in bufferList)
                {
                    size = buffer.Length;
                    if (offset == 0)
                    {
                        Array.Copy(buffer, bufferReadOffset, returnData, offset, size - bufferReadOffset);
                        offset += (size - bufferReadOffset);
                    }
                    else
                    {
                        Array.Copy(buffer, 0, returnData, offset, size);
                        offset += size;
                    }
                }
            }

            return returnData;
        }

        // obt@ꕔ폜
        private bool internalDelete(int deleteBytes)
        {
            bufferReadOffset = 0;

            lock (bufferList)
            {
                while (deleteBytes >= 0)
                {
                    if (bufferList.Count == 0)
                        return false;
                    else
                    {
                        // ŌÃobt@TCY > 폜TCY
                        //   ŌÃobt@TCYɃItZbg悤ɂďI
                        // ŌÃobt@TCY <= 폜TCY
                        //   ŌÃobt@폜āC폜TCY
                        if (bufferList[0].Length > deleteBytes)
                        {
                            bufferReadOffset = deleteBytes;
                            return true;
                        }
                        else
                        {
                            deleteBytes -= bufferList[0].Length;
                            bufferList.RemoveAt(0);
                        }
                    }
                }
            }
            return true;
        }

        // TCYvZ
        private int internalGetSize()
        {
            int size = 0;
            foreach (byte[] buffer in bufferList)
            {
                size += buffer.Length;
            }
            size -= bufferReadOffset;

            return size;
        }

        /// <summary>
        /// f[^ǉCxgD
        /// Get\bhgĎ擾ĂD
        /// </summary>
        public event EventHandler Added;

        /// <summary>
        /// f[^ǉ܂D
        /// </summary>
        /// <param name="addData">ǉf[^</param>
        /// <param name="addBytes">f[^</param>
        public void Add(byte[] addData, int addBytes)
        {
            internalAdd(addData, addBytes);
            Added(this, EventArgs.Empty);
        }

        /// <summary>
        /// f[^擾܂D
        /// </summary>
        /// <param name="getBytes">擾oCg (-1: ׂ)</param>
        /// <returns>f[^</returns>
        public byte[] Get(int getBytes)
        {
            return internalGet();
        }

        /// <summary>
        /// f[^̈ꕔ폜܂D
        /// 폜ɎsꍇCf[^͕sSȏԂŎc܂D
        /// </summary>
        /// <param name="deleteBytes">폜oCg</param>
        /// <returns>true: , false: s</returns>
        public bool Delete(int deleteBytes)
        {
            return internalDelete(deleteBytes);
        }

        /// <summary>
        /// ΃sA\Pbg(AsyncSocket)MCxgɑ΂郁\bhD
        /// </summary>
        /// <param name="sender">M</param>
        /// <param name="e">p^</param>
        public void OnRead(object sender, ByteArrayReadEventArgs e)
        {
            Add(e.readData, e.readBytes);
        }
    }
}
